class WQMLR_draw_chart
{
    constructor(id= "", type="bar")
    {
        this.id= id;
        this.ctx= null;
        this.chart= null;
        this.type= type;
        this.labels= ['RECIPIENTS', 'DELIVERED MAILS', 'SEEN', 'LINK VISITS', 'PENDING MAILS', 'BOUNCED MAILS'];
        this.data= [0, 0, 0, 0, 0, 0];
    }
    draw()
    {
        try
        {
            this.ctx = document.getElementById(this.id).getContext('2d');
            this.chart = new Chart(this.ctx, {
                type: this.type,
                data: {
                    labels: this.labels,
                    datasets: [{
                        label: '',
                        data: this.data,
                        backgroundColor: [
                            '#00cccc',
                            '#40bf80',
                            '#00bfff',
                            '#ffb366',
                            '#ff4d94',
                            '#ff80bf'
                        ],
                        borderColor: [
                            '#008080',
                            '#2d8659',
                            '#0086b3',
                            '#ff9933',
                            '#ff0066',
                            '#ff3399'
                        ],
                        borderWidth: 1
                    }]
                },
                options: {
                    legend: {
                        display: false
                    },
                    scales: {
                        y: {
                            beginAtZero: true,
                        }
                    },
                    responsive: true,
                    maintainAspectRatio: true,
                }
            });
        }catch(err){console.log(err);}
    }
    update(data)
    {
        let changed= false;
        for(let i=0; i<data.length; i++)
        {
            if(data[i] !==this.data[i])
            {
                changed= true;
                break;
            }
        }
        if(!changed){return;}

        this.data= data;
        this.chart.data.datasets.forEach((dataset) => {
            dataset.data.splice(0, dataset.data.length);
            dataset.data= data;
        });
        this.chart.update();
    }
}