<?php
/*
PLUGIN NAME:MailEngine Pro
Plugin URI: http://www.teknikforce.com
DESCRIPTION: Powerful self hosted autoresponder system
AUTHOR:20script
AUTHOR URI:https://www.20script.ir
Version: 3.5
*/

update_option('wp_quick_mlr_licensed', 1);
update_option('wp_quick_mlr_license_auth', '*******');

require 'assets/plugin-update-checker/plugin-update-checker.php';
$myUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
	'https://teknikforce.com/appcasts/wpplugins/wpmailenginepro.json',
	__FILE__, //Full path to the main plugin file or functions.php.
	'mailenginepro'
);
class QuickMailInstallation
{
	function __construct()
	{
		register_activation_hook( __FILE__, array($this,'quickmailInstall'));
	}
	function quickmailInstall()
	{
		//add option

		$pref="wp_quick_mlr_";
		add_option($pref.'mail_attempt','0');
		add_option($pref.'current_listid','0');
		add_option($pref.'sequence_otp',date('d-M-Y h:ia'));

		add_option($pref.'subs_home','0');
		add_option($pref.'subs_global','0');

		add_option($pref.'compose_spin_text','');
		add_option($pref.'compose_spin_url','');

		add_option($pref.'schedule_spin_text','');
		add_option($pref.'schedule_spin_url','');

		add_option($pref.'sequence_spin_text','');
		add_option($pref.'sequence_spin_url','');

		add_option($pref.'only_url_shortcode','0');

		add_option($pref.'send_noof_mail_at_chunk','30');

		add_option($pref.'compose_delay_sec','20');

		add_option($pref.'send_noof_mail_sch_min','30');

		add_option($pref.'redirection_page_mail_content','1');

		$scheduleapitoken=substr(str_shuffle('1234567890zxcvbnmasdfghjkklqwertyuiopASDFGHJKLZXCVBNMQWERTYUIIIIOP@%^&*(){}[]|-+/><.,'),1,10);

		add_option($pref.'schedule_api_token',$scheduleapitoken);

		$scheduleapiurl=plugins_url('wpquickmailer/schedule_api.php',__FILE__);

		add_option($pref.'schedule_api_url',$scheduleapiurl);

		add_option($pref.'dont_close_forms','@');

	$currentuseralldata=wp_get_current_user();
	$contactdetaileditor="<p>To contact us email at <a href='mailto:".$currentuseralldata->user_email."'>".$currentuseralldata->user_email."</a> or visit our site <a href='".site_url()."'>".site_url()."</a></p>";
		add_option($pref.'contact_template',$contactdetaileditor);

		//add_option($pref.'redirection_page_id','0');
		//unsuscribe pagecreate
		self::unSubscribePageCreate();

		global $wpdb;
		$charset_collate='';
		if (!empty($wpdb->charset))
	{
	$charset_collate = "DEFAULT CHARACTER SET {$wpdb->charset}";
	}
	if (!empty($wpdb->collate))
	{
        $charset_collate .= " COLLATE {$wpdb->collate}";
	}
	//table for email sending settings
		$table_name = $wpdb->prefix . 'quick_mlr_email_setting';

		 $sqlqmes = "CREATE TABLE IF NOT EXISTS {$table_name} (" .

			"`id` bigint NOT NULL AUTO_INCREMENT,".
			"`title` varchar(255) NOT NULL,".
			"`fromemail` varchar(255) NOT NULL,".
			"`fromname` varchar(255) NOT NULL,".
			"`replyemail` varchar(255) NOT NULL,".
			"`replyname` text,".
			"`date` varchar(255) NOT NULL,".
            "PRIMARY KEY (`id`)".
            ") {$charset_collate} ENGINE=InnoDB;";
            $wpdb->query($sqlqmes );

            //table for smtp settings
        $table_name = $wpdb->prefix . 'quick_mail_smtp_settings';

		 $sql0 = "CREATE TABLE IF NOT EXISTS {$table_name} (" .

			"`id` bigint NOT NULL AUTO_INCREMENT,".
			"`title` varchar(255) NOT NULL,".
			"`fromemail` varchar(255) NOT NULL,".
			"`hostname` text NOT NULL,".
			"`port` text NOT NULL,".
			"`server` text NOT NULL,".
			"`imap_credentials` text NOT NULL,".
			"`username` text NOT NULL,".
			"`password` text NOT NULL,".
			"`encryption` varchar(255) NOT NULL,".
			"`date` varchar(255) NOT NULL,".
            "PRIMARY KEY (`id`)".
            ") {$charset_collate} ENGINE=InnoDB;";
            $wpdb->query($sql0);

			//table for mail sending log
			$tablename=$wpdb->prefix."quick_mail_mailsending_report";
			$sqlqry="CREATE TABLE IF NOT EXISTS {$tablename} (".
			"`id` bigint NOT NULL AUTO_INCREMENT,".
			"`attempt` varchar(255) NOT NULL,".
			"`listid` varchar(255) NOT NULL,".
			"`smtpid` varchar(255) NOT NULL,".
			"`fromid` varchar(255) NOT NULL,".
			"`email` varchar(255) NOT NULL,".
			"`status` text NOT NULL,".
			"`error` varchar(255) NOT NULL,".
			"`sentdata` text NOT NULL,".
			"`extraemails` text NOT NULL,".
			"`spintext` varchar(255) NOT NULL,".
			"`spinurl` varchar(255) NOT NULL,".
			"`emailtopost` varchar(255) NOT NULL,".
			"`date` varchar(255) NOT NULL,".
			"`time` varchar(255) NOT NULL,".
			"PRIMARY KEY(`id`)".
			") {$charset_collate} ENGINE=InnoDB;";

			$wpdb->query($sqlqry);

	        //table for list record

	        $tablenamethis=$wpdb->prefix."wquick_mail_list_records";
			$sqlqryt="CREATE TABLE IF NOT EXISTS {$tablenamethis} (".
			"`id` bigint NOT NULL AUTO_INCREMENT,".
			"`title` varchar(255) NOT NULL,".
			"`creationdate` varchar(255) NOT NULL,".
			"PRIMARY KEY(`id`)".
			") {$charset_collate} ENGINE=InnoDB;";

			$wpdb->query($sqlqryt);

			//url shortcode
			$tablenamethis=$wpdb->prefix."quick_mail_links_with_shortcode";
			$sqlqryt="CREATE TABLE IF NOT EXISTS {$tablenamethis} (".
			"`id` bigint NOT NULL AUTO_INCREMENT,".
			"`url` varchar(255) NOT NULL,".
			"`token` varchar(255) NOT NULL,".
			"`createdon` varchar(255) NOT NULL,".
			"PRIMARY KEY(`id`)".
			") {$charset_collate} ENGINE=InnoDB;";
			$wpdb->query($sqlqryt);

	        //table for mail list
			$tablename=$wpdb->prefix."quick_mail_email_lists";
			$sqlqry="CREATE TABLE IF NOT EXISTS {$tablename} (".
			"`id` bigint NOT NULL AUTO_INCREMENT,".
			"`listid` varchar(255) NOT NULL,".
			"`name` varchar(255) NOT NULL,".
			"`email` text NOT NULL,".
			"`exf` text NOT NULL,".
            "`ipadr` text NOT NULL,".
			"`date` text NOT NULL,".
			"PRIMARY KEY(`id`)".
			") {$charset_collate} ENGINE=InnoDB;";

			$wpdb->query($sqlqry);

			//table for links visit
			$tablenamee=$wpdb->prefix.'quick_mailer_links_visits';
			$sqlqryy="CREATE TABLE IF NOT EXISTS {$tablenamee} (".
			"`id` bigint NOT NULL AUTO_INCREMENT,".
			"`emailattempt` varchar(255) NOT NULL,".
			"`link` text NOT NULL,".
			"`visits` varchar(255) NOT NULL,".
			"`visitedby` text NOT NULL,".
			"`otp` varchar(255) NOT NULL,".
			"`exf` text NOT NULL,".
			"`date` text NOT NULL,".
			"PRIMARY KEY(`id`)".
			") {$charset_collate} ENGINE=InnoDB;";

			$wpdb->query($sqlqryy);

			//table for subscription setting
			$tablenamesubs=$wpdb->prefix."quick_mailer_subscription_settings";
			$sqlqrysubsform="CREATE TABLE IF NOT EXISTS {$tablenamesubs}(".
			"`id` bigint NOT NULL AUTO_INCREMENT,".
			"`title` varchar(255) NOT NULL,".
			"`selectedlist` varchar(255) NOT NULL,".
			"`formtitle` varchar(255) NOT NULL,".
			"`formtitletxtsize` varchar(255) NOT NULL,".
			"`formtitletxtcolor` varchar(255) NOT NULL,".
			"`description` text NOT NULL,".
			"`name` varchar(255) NOT NULL,".
			"`email` varchar(255) NOT NULL,".
			"`customcss` text NOT NULL,".
			"`subscriberbtntext` varchar(255) NOT NULL,".
			"`subscriberbgcolor` varchar(255) NOT NULL,".
			"`subscribertxtcolor` varchar(255) NOT NULL,".
			"`nameplaceholder` varchar(255) NOT NULL,".
			"`emailplaceholder` varchar(255) NOT NULL,".
			"`boxtype` varchar(255) NOT NULL,".
			"`displaydelay` varchar(255) NOT NULL,".
			"`exfs` text NOT NULL,".
			"`date` varchar(255) NOT NULL,".
			"PRIMARY KEY(`id`)".
			") {$charset_collate} ENGINE=InnoDB;";

			$wpdb->query($sqlqrysubsform);

			//table for schedule mails
			$tablename=$wpdb->prefix."qmlr_eml_scheedular";
			$sqlqryschdl="CREATE TABLE IF NOT EXISTS {$tablename} (".
			"`id` bigint NOT NULL AUTO_INCREMENT,".
			"`listid` varchar(255) NOT NULL,".
			"`smtpid` varchar(255) NOT NULL,".
			"`fromid` varchar(255) NOT NULL,".
			"`status` text NOT NULL,".
			"`sentdata` text NOT NULL,".
			"`extraemails` text NOT NULL,".
			"`sdate` varchar(255) NOT NULL,".
			"`stime` varchar(255) NOT NULL,".
			"`stimezone` varchar(255) NOT NULL,".
			"`stoken` varchar(255) NOT NULL,".
			"`spintext` varchar(255) NOT NULL,".
			"`spinurl` varchar(255) NOT NULL,".
			"`emailtopost` varchar(255) NOT NULL,".
			"`mailssent` text NOT NULL,".
			"`attempt` varchar(255) NOT NULL,".
			"`date` varchar(255) NOT NULL,".
			"`time` varchar(255) NOT NULL,".
			"PRIMARY KEY(`id`)".
			") {$charset_collate} ENGINE=InnoDB;";

			$wpdb->query($sqlqryschdl);

			//unsubscription table
			$tablename=$wpdb->prefix."quick_mailer_unsubscribe_users";
			$sqlqryunsubs="CREATE TABLE IF NOT EXISTS {$tablename} (".
			"`id` bigint NOT NULL AUTO_INCREMENT,".
			"`attempt` varchar(255) NOT NULL,".
			"`listid` varchar(255) NOT NULL,".
			"`email` varchar(255) NOT NULL,".
			"`status` text NOT NULL,".
			"`date` varchar(255) NOT NULL,".
			"`time` varchar(255) NOT NULL,".
			"PRIMARY KEY(`id`)".
			") {$charset_collate} ENGINE=InnoDB;";

			$wpdb->query($sqlqryunsubs);

			//list sequence email setting
			$tablename=$wpdb->prefix."qmlr_list_subs_sequence";
			$sqlqrysqnc="CREATE TABLE IF NOT EXISTS {$tablename} (".
			"`id` bigint NOT NULL AUTO_INCREMENT,".
			"`listid` varchar(255) NOT NULL,".
			"`smtpid` varchar(255) NOT NULL,".
			"`fromid` varchar(255) NOT NULL,".
			"`sentdata` text NOT NULL,".
			"`stimezone` varchar(255) NOT NULL,".
			"`sequence` varchar(255) NOT NULL,".
			"`spintext` varchar(255) NOT NULL,".
			"`spinurl` varchar(255) NOT NULL,".
			"`date` varchar(255) NOT NULL,".
			"`time` varchar(255) NOT NULL,".
			"`updatedon` varchar(255) NOT NULL,".
			"PRIMARY KEY(`id`)".
			") {$charset_collate} ENGINE=InnoDB;";

			$wpdb->query($sqlqrysqnc);
			//schedule subscription mail
			$tablename=$wpdb->prefix."qmlr_subscription_mail_schedule";
			$sqlqryschdlsubs="CREATE TABLE IF NOT EXISTS {$tablename} (".
			"`id` bigint NOT NULL AUTO_INCREMENT,".
			"`seqid` varchar(255) NOT NULL,".
			"`listid` varchar(255) NOT NULL,".
			"`smtpid` varchar(255) NOT NULL,".
			"`fromid` varchar(255) NOT NULL,".
			"`status` text NOT NULL,".
			"`sentdata` text NOT NULL,".
			"`extraemails` text NOT NULL,".
			"`sdate` varchar(255) NOT NULL,".
			"`stime` varchar(255) NOT NULL,".
			"`stimezone` varchar(255) NOT NULL,".
			"`stoken` varchar(255) NOT NULL,".
			"`spintext` varchar(255) NOT NULL,".
			"`spinurl` varchar(255) NOT NULL,".
			"`date` varchar(255) NOT NULL,".
			"`time` varchar(255) NOT NULL,".
			"PRIMARY KEY(`id`)".
			") {$charset_collate} ENGINE=InnoDB;";

			$wpdb->query($sqlqryschdlsubs);


			//Schedule API table

			$qryapi="CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."qmlr_api_schedular_table` (".
					"`id` bigint NOT NULL AUTO_INCREMENT,".
					"`cburl` text NOT NULL,".
					"`stoken` varchar(255) NOT NULL,".
					"`stime` bigint NOT NULL,".
					"`status` varchar(255) NOT NULL,".
					"`ip` varchar(255) NOT NULL,".
					"`date` varchar(255) NOT NULL,".
					"`time` varchar(255) NOT NULL,".
					"PRIMARY KEY(`id`)".
					"){$charset_collate} ENGINE=InnoDB;";


			$wpdb->query($qryapi);
	}

	function unSubscribePageCreate()
	{//page create for un subscription
		require_once('wpquickmailer/unsubscribe.php');
		$ob=new quickmlr_unsb_class();
		$ob->qmlr_add_custom_unsubscription_page();
		$ob->createRedirectionPage();
	}
}
$wpqinstall=new QuickMailInstallation();


class MenuPageCreation
{

	function __construct()
	{
		require_once("scheduler/qmlr.php");
        $gdprwpvar=new wpquickmailerpluginlisence(array('mailenginepro','wp_quick_mlr_'));
        if($gdprwpvar->validate()==1)
		{
		add_action('admin_menu',array($this,'quick_mail_menus'));
		}
		else
		{
			new wpquickmaileractivationpage(array('mailenginepro','wp_quick_mlr_'));
		}
	}
	function quick_mail_menus()
	{
		global $submenu;

		add_menu_page('MailEngine','MailEngine','administrator','wp_quick_mlr',array($this,'quick_mlr_dashboard'),'dashicons-format-status');

		add_submenu_page('wp_quick_mlr','MailEngine','SMTPs','administrator','wqmlr_manage_smtp',array($this,'manage_smtp_settings' ));

		add_submenu_page('wp_quick_mlr','MailEngine','Create New SMTP','administrator','wqmlr_smtp_create_new',array($this,'ceate_new_smtp'));

		add_submenu_page('wp_quick_mlr','MailEngine','Links','administrator','wqmlr_generated_links',array($this,'wpQuickMailerLinkVisitsAndLinksCode'));

		add_submenu_page('wp_quick_mlr','MailEngine','Gmail API','administrator','wp_crt_gmail_api',array($this,'wpqmlr_create_gmail_api'));

		add_submenu_page('wp_quick_mlr','MailEngine','Gmail APIs','administrator','wp_all_gmail_api',array($this,'wpqmlr_gmail_api_list'));

		add_submenu_page('wp_quick_mlr','MailEngine','From Emails','administrator','wqmlr_email_settings',array($this,'email_settings'));

		add_submenu_page('wp_quick_mlr','MailEngine','Edit Settings','administrator','wqmlrr_edit_settings',array($this,'edit_settings'));

		add_submenu_page('wp_quick_mlr','MailEngine','Lists','administrator','wp_quickmlr_lists',array($this,'email_list'));

		add_submenu_page('wp_quick_mlr','MailEngine','Create Lists','administrator','wp_quickmlr_create_lists',array($this,'create_list'));

		add_submenu_page('wp_quick_mlr','MailEngine','Prioritize Lists','administrator','wp_quickmlr_prioritize_lists',array($this,'prioritize_list'));

		add_submenu_page('wp_quick_mlr','MailEngine','Mail Sequence Setting','administrator','wp_quickmlr_list_sequence_setting',array($this,'create_list_sequence'));

		add_submenu_page('wp_quick_mlr','MailEngine','Mail Sequence','administrator','wp_quickmlr_list_sequence_records',array($this,'list_sequence_records'));

		add_submenu_page('wp_quick_mlr','MailEngine','Campaigns','administrator','wqmlr_page_campaign',array($this,'qmlrCampaignPage'));

		add_submenu_page('wp_quick_mlr','MailEngine','Compose Mail','administrator','wp_compose_email',array($this,'compose_email' ));

		add_submenu_page('wp_quick_mlr','MailEngine','Live Sending status','administrator','wqmlr_live_sending_stat',array($this,'live_sending' ));

		add_submenu_page('wp_quick_mlr','MailEngine','History','administrator','wp_quickmlr_mail_history',array($this,'snd_email_history' ));

		add_submenu_page('wp_quick_mlr','MailEngine','Mails Sent','administrator','wp_quickmlr_mails_sent',array($this,'snd_email_history_sent' ));

		add_submenu_page('wp_quick_mlr','MailEngine','Status Details','administrator','wp_quickmlr_sent_emails_details',array($this,'detail_snt_emails_display' ));


		add_submenu_page('wp_quick_mlr','MailEngine','Scheduled Mails','administrator','wp_quickmlr_schedule_records',array($this,'wpQuickMailerSchdlRecords'));

		/*add_submenu_page('wp_quick_mlr','WP QuickMailer','Schedule Mails','administrator','wp_quickmlr_schedule_mails',array($this,'wpQuickMailerSchdlMails'));*/

	
		add_submenu_page('wp_quick_mlr','MailEngine','Email Verification','administrator','wp_quickmlr_mail_email_verification',array($this,'wpQuickMailerEmailVerification'));


		add_submenu_page('wp_quick_mlr','MailEngine','Links Visits','administrator','wp_quickmlr_mail_links_visit',array($this,'wpQuickMailerLinkVisits'));

		add_submenu_page('wp_quick_mlr','MailEngine','Subscription Forms','administrator','wp_quickmlr_subscription_forms',array($this,'quickmlr_subscribtion_forms' ));

		add_submenu_page('wp_quick_mlr','MailEngine','Subscription Setting','administrator','wp_quickmlr_subscriptionform',array($this,'quickmlr_subscribtion_form_setup' ));

		add_submenu_page('wp_quick_mlr','MailEngine','Subscription Records','administrator','wp_quickmlr_subscription_records',array($this,'wpQuickMailerSubsRecords'));

		add_submenu_page('wp_quick_mlr','MailEngine','Email Settings','administrator','wp_qmlr_delay',array($this,'wpqmlr_delay'));

		add_submenu_page('wp_quick_mlr','MailEngine','Error Log','administrator','wp_qmlr_err_log',array($this,'wpqmlr_err_log'));

		$submenu['wp_quick_mlr'][0][0]="Dashboard";
	}
	function quick_mlr_dashboard()
	{
      require_once('wpquickmailer/dashboard.php');
	}
	function qmlrCampaignPage()
	{
	 require_once('wpquickmailer/campaign_page.php');
	}
	function manage_smtp_settings()
	{
		require_once('wpquickmailer/smtprecordtable.php');

	}
		function ceate_new_smtp()
	{
		require_once('wpquickmailer/function.php');
		$createobj=new wpQMailerMailSending();
		$createobj->load_quick_mail_settings();
    }
	function email_settings()
	{
		//require_once('wpquickmailer/emailsetting.php');
		require_once('wpquickmailer/emailsttngrecord.php');


	}
	function edit_settings()
	{
		require_once('wpquickmailer/emailsettngfunc.php');
		$objj=new quickEmailSttngSave();
		$objj->load_email_setting();

	}
	function compose_email()
	{
       require_once('wpquickmailer/composemailfunction.php');
	   $ob=new wpquickmailcomposemail();
	   $ob->loadComposeMailSettingPage();
	}
	function live_sending()
	{
		require_once("wpquickmailer/live_mail_status_function.php");
		$ob= new WQMLR_live_mail_status();
		$ob->loadPage();
	}
	function snd_email_history()
	{
		require_once('wpquickmailer/mailhistory.php');
	}

	function detail_snt_emails_display()
	{
		require_once('wpquickmailer/typemails.php');
	}

	function snd_email_history_sent()
	{
		require_once('wpquickmailer/emailssent.php');
	}

	function email_list()
	{
		require_once('wpquickmailer/listrecords.php');

	}
	function create_list()
	{
		require_once('wpquickmailer/listfunc.php');
		$obj_list=new wpQuickSaveList();
		$obj_list->load_list_settings();
	}
	function prioritize_list()
	{
		require_once('wpquickmailer/listfunc.php');
		$obj_list=new wpQuickSaveList();
		$obj_list->load_prioritize_settings();
	}
	function wpQuickMailerEmailVerification()
	{
		require_once('wpquickmailer/email_verification_function.php');
		$ob= new Wpqmlr_email_verification();
		$ob->loadSetupPage();
	}
	function wpQuickMailerLinkVisitsAndLinksCode()
	{
		require_once('wpquickmailer/links.php');
	}
	function wpQuickMailerLinkVisits()
	{
		require_once('wpquickmailer/linksvisits.php');
	}
	function quickmlr_subscribtion_forms()
	{
		require_once('wpquickmailer/subscriberformtable.php');
	}
	function quickmlr_subscribtion_form_setup()
	{
		require_once('wpquickmailer/subscriptionfunction.php');
		$ob=new Usersightsubscriptionformwq();
		$ob->loadSubscriptionSettingpage();
	}

	function wpQuickMailerSubsRecords()
	{
		require_once('wpquickmailer/subscriberrecords.php');
	}

	function wpQuickMailerSchdlMails()
	{
		require_once('wpquickmailer/schedulefunc.php');
		$schobj=new wpqkmlschdlmail();
		$schobj->loadScheduleMailSettingPage();
	}

	function wpQuickMailerSchdlRecords()
	{
		require_once('wpquickmailer/schedulefunc.php');
		$schobj=new wpqkmlschdlmail();
		$schobj->loadSchedularRecordsPage();
	}

	function wpqmlr_err_log()
	{
		require_once('wpquickmailer/errlog.php');
	}

	function create_list_sequence()
	{
		require_once('wpquickmailer/subssequencefunc.php');
		$ob=new Subssequencefunc();
		$ob->sequenceSettingPage();
	}
	function list_sequence_records()
	{
		require_once('wpquickmailer/subssequencefunc.php');
		$ob=new Subssequencefunc();
		$ob->sequenceRecordPage();
	}
	function wpqmlr_create_gmail_api()
	{
		require_once('wpquickmailer/gmail/control.php');
		$ob=new Gmailapisend();
		$ob->loadApiSetting();
	}
	function wpqmlr_gmail_api_list()
	{
		require_once('wpquickmailer/gmail/control.php');
		$ob=new Gmailapisend();
		$ob->allSettings();
	}
	function wpqmlr_delay()
	{
		require_once('wpquickmailer/delaysettings_func.php');
		$obj = new DelaySaveSettings();
		$obj->loadDelaySettingsPage();
	}

}
$wpqmenus=new MenuPageCreation();


class wpQuickMlrCommonStyles
{

	function __construct()
	{
		require_once('assets/quickmlrstyles.php');
		$styleobj=new wpQuickMailerCommonStyle();
		$styleobj->wpQuickMlrPanelCommonStyle();
	}
}
$wpquickmlrstyle=new wpQuickMlrCommonStyles();

class wpQuickMlrCommonScripts
{
	function __construct()
	{
	add_action('admin_enqueue_scripts',array($this,'commonWqScripts'));
	add_action('wp_enqueue_scripts',array($this,'userSightWqScript'));
	self::loadEditorStyles();
	}
	function commonWqScripts()
	{
		require_once('assets/quickmlrstyles.php');
	$ob=new wpQuickMailerCommonStyle();
	$ob->wpQuickMailerCommonScript();
	}
	function userSightWqScript()
	{
		require_once('assets/quickmlrstyles.php');
	$ob=new wpQuickMailerCommonStyle();
	$ob->wqQuickMailerUserSightJs();
	}
	function loadEditorStyles()
	{
		require_once('assets/quickmlrstyles.php');
	    $ob=new wpQuickMailerCommonStyle();
		$ob->filtersForFontSizeAndStyleInEditor();
	}
}
$enquuuescriptstyle=new wpQuickMlrCommonScripts();

class wpqmlrusersightsettings
{
	function __construct()
	{
		require_once('wpquickmailer/function.php');
		$createobj=new wpQMailerMailSending();
		 $createobj->initLinkVisitSetting();
	}
}
$usersightsettings=new wpqmlrusersightsettings();


class Wqmailerdisplayshortcodeform
{
	//all short codes
	function __construct()
	{
		require_once('wpquickmailer/subscriptionfunction.php');
		$ob=new Usersightsubscriptionformwq();
		$ob->wqmlrUserSightAddShortCode();


		require_once('wpquickmailer/unsubscribe.php');
		$ob=new quickmlr_unsb_class();
		$ob->qmlrUnsubscribeShortCode();
	    $ob->filterContentForRedirectionPage();
		$ob->callBackScheduleURlChangeNotice();

	}
}
$wqshortcodeob=new Wqmailerdisplayshortcodeform();

class Qmlremail_return_path {
	function __construct() {
		if(isset($_SERVER['HTTP_HOST']))
		{
			$url=$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
			if(strpos($url,'/wpquickmailer/')>0)
			{	
			add_action( 'phpmailer_init', array( $this, 'fix' ) );  
			}  
		}
	}

  function fix( $phpmailer ) {
		if(get_option('qmlr_wpmlrbounce_imap_credentials'))
		{
		$imap_ob=json_decode(get_option('qmlr_wpmlrbounce_imap_credentials'));
		if(isset($imap_ob->return_path))
			{	
				if(filter_var($imap_ob->return_path,FILTER_VALIDATE_EMAIL))
				{	
				$phpmailer->Sender = $imap_ob->return_path;
				}
			}
		}
  }
}

new Qmlremail_return_path();



//handle ajax requests
class WPQMlr_ajax_request_handler
{
	function __construct()
	{
		add_action('wp_ajax_email_verification', array($this, 'email_verification'));
		add_action('wp_ajax_wqmlr_live_sending', array($this, 'live_sending'));
	}
	function email_verification(){
		require_once('wpquickmailer/ajax_email_verification.php');
		die();
	}
	function live_sending()
	{
		//@ini_set( 'display_errors', 1 );
		require_once("wpquickmailer/live_mail_status_function.php");
		$ob= new WQMLR_live_mail_status();
		$data= $ob->getStatus($_POST['id'], $_POST['type']);
		echo json_encode($data);
		die();
	}
}
new WPQMlr_ajax_request_handler();
?>
