<?php

/* This is a sample callback function for PHPMailer-BMH (Bounce Mail Handler).
 * This callback function will echo the results of the BMH processing.
 */
/**
 * Callback (action) function
 *
 * @param int         $msgnum       the message number returned by Bounce Mail Handler
 * @param string      $bounceType   the bounce type:
 *                                  'antispam','autoreply','concurrent','content_reject','command_reject','internal_error','defer','delayed'
 *                                  =>
 *                                  array('remove'=>0,'bounce_type'=>'temporary'),'dns_loop','dns_unknown','full','inactive','latin_only','other','oversize','outofoffice','unknown','unrecognized','user_reject','warning'
 * @param string      $email        the target email address
 * @param string      $subject      the subject, ignore now
 * @param string      $xheader      the XBounceHeader from the mail
 * @param bool        $remove       remove status, 1 means removed, 0 means not removed
 * @param bool|string $ruleNo       bounce Mail Handler detect rule no
 * @param bool|string $ruleCat      bounce Mail Handler detect rule category
 * @param int         $totalFetched total number of messages in the mailbox
 * @param string      $body         Bounce Mail Body
 * @param string      $headerFull   Bounce Mail Header
 * @param string      $bodyFull     Bounce Mail Body (full)
 *
 * @return bool
 */
function callbackAction($msgnum, $bounceType, $email, $subject, $xheader, $remove, $ruleNo = false, $ruleCat = false, $totalFetched = 0, $body = '', $headerFull = '', $bodyFull = ''): bool
{
    $displayData = prepData($email, $bounceType, $remove);
    $bounceType = $displayData['bounce_type'];
    $emailName = $displayData['emailName'];
    $emailAddy = $displayData['emailAddy'];
    $remove = $displayData['remove'];
    global $wpdb;


    $tempbodyFull=str_replace("=3D","",$bodyFull);
    $tempbodyFull=str_replace("<img","",$tempbodyFull);
    $tempbodyFull= preg_replace('/<[^>]*>/', '',$tempbodyFull);
    $tempbodyFull=preg_replace( "/\r|\n/", "",$tempbodyFull);
    $tempbodyFull=strip_tags(html_entity_decode($tempbodyFull));
    $tempbodyFull=str_replace("=","",$tempbodyFull);
    $tempbodyFull=str_replace("://","",$tempbodyFull);
    $tempbodyFull=str_replace("/","",$tempbodyFull);
    
    
    $cutstrfrom=strpos($tempbodyFull,"@strtqmlrbouncehandler");
    if($cutstrfrom>1)
    {
        $cutstrfrom +=22;
        $cutendat=strpos($tempbodyFull,"@qmlrbouncehandler");
       // @qmlrtracerstart".base64_encode(site_url())."@qmlrtracerend

         $chksiteurlstart=strpos($tempbodyFull,"@qmlrtracerstart");
        
         $siteurlmatched=0;
        if($chksiteurlstart>0)
        {
            $chksiteurlstart +=16;
            $checksiteurlend=strpos($tempbodyFull,"@qmlrtracerend");
            $tempsiteurl=substr($tempbodyFull,$chksiteurlstart,($checksiteurlend-$chksiteurlstart));
            if($tempsiteurl==$GLOBALS['qmlrsiteurl'])
            {
                ++$siteurlmatched;
            }
        }

        if(($cutendat>0) &&($siteurlmatched))
        {
        $tempattempt=substr($tempbodyFull,$cutstrfrom,($cutendat-$cutstrfrom));
        if(is_numeric($tempattempt))
        {
            if(in_array($bounceType,$GLOBALS['qmlrbouncetypes']))
            {
            $tempqmlrbouncecause="Type: ".$bounceType."| Category: ".$ruleCat."| Subject:".$subject;    
            $wpdb->query($wpdb->prepare("update `".$GLOBALS['qmlrreporttable']."` set `status`='5',`error`=%s where `attempt`=%s and `email`=%s",array($tempqmlrbouncecause,$tempattempt,$email)));
            }
            if((($bounceType==$GLOBALS['qmlrdeletebouncesfromlist'])||($GLOBALS['qmlrdeletebouncesfromlist']=="all"))&&($bounceType !="none"))
            {
            $wpdb->query($wpdb->prepare("delete from `".$wpdb->prefix."quick_mail_email_lists` where `email`=%s",array($email)));
            }
        }
        }
    }
  
    echo $msgnum . ': ' . $ruleNo . ' | ' . $ruleCat . ' | ' . $bounceType . ' | ' . $remove . ' | ' . $email . ' | ' . $subject . "<br />\n";
   
    return true;
}
/**
 * Function to clean the data from the Callback Function for optimized display
 *
 * @param $email
 * @param $bounceType
 * @param $remove
 *
 * @return mixed
 */
function prepData($email, $bounceType, $remove)
{
    $data['bounce_type'] = \trim($bounceType);
    $data['email'] = '';
    $data['emailName'] = '';
    $data['emailAddy'] = '';
    $data['remove'] = '';
    if (\strpos($email, '<') !== false) {
        $pos_start = \strpos($email, '<');
        $data['emailName'] = \trim(\substr($email, 0, $pos_start));
        $data['emailAddy'] = \substr($email, $pos_start + 1);
        $pos_end = \strpos($data['emailAddy'], '>');
        if ($pos_end) {
            $data['emailAddy'] = \substr($data['emailAddy'], 0, $pos_end);
        }
    }
    // replace the < and > able so they display on screen
    $email = \str_replace(['<', '>'], ['&lt;', '&gt;'], $email);
    // replace the "TO:<" with nothing
    $email = \str_ireplace('TO:<', '', $email);
    $data['email'] = $email;
    // account for legitimate emails that have no bounce type
    if (\trim($bounceType) == '') {
        $data['bounce_type'] = 'none';
    }
    // change the remove flag from true or 1 to textual representation
    if (\stripos($remove, 'moved') !== false && \stripos($remove, 'hard') !== false) {
        $data['removestat'] = 'moved (hard)';
        $data['remove'] = '<span style="color:red;">' . 'moved (hard)' . '</span>';
    } elseif (\stripos($remove, 'moved') !== false && \stripos($remove, 'soft') !== false) {
        $data['removestat'] = 'moved (soft)';
        $data['remove'] = '<span style="color:gray;">' . 'moved (soft)' . '</span>';
    } elseif ($remove == true || $remove == '1') {
        $data['removestat'] = 'deleted';
        $data['remove'] = '<span style="color:red;">' . 'deleted' . '</span>';
    } else {
        $data['removestat'] = 'not deleted';
        $data['remove'] = '<span style="color:gray;">' . 'not deleted' . '</span>';
    }
    return $data;
}
?>