<?php
class Qmlr_gmail
{
	var $client;
	var $clientid;
	var $secret;
	var $redirect;
	function __construct($clientid,$secret,$redirect)
	{
     require 'vendor/autoload.php'; // or wherever autoload.php is located
     $this->client = new Google_Client();
	 
	 $this->clientid=$clientid;
	 $this->secret=$secret;
	 $this->redirect=$redirect;
	 self::initGmail();
	}
	
	function initGmail()
	{
	//
	$client=$this->client;
	//Client id and secret assignment
    $client->setClientId($this->clientid);
    $client->setClientSecret($this->secret);
	//redirect url
    $client->setRedirectUri($this->redirect);
	
	$client->setAccessType('offline');
    $client->setApprovalPrompt('force');
  
    $client->addScope("https://mail.google.com/");
    $client->addScope("https://www.googleapis.com/auth/gmail.compose");
    $client->addScope("https://www.googleapis.com/auth/gmail.modify");
    $client->addScope("https://www.googleapis.com/auth/gmail.readonly");
	
	}
	
	function getRedirectonURL()
	{//Get Redirection url for auth
		$url = $this->client->createAuthUrl();
        return $url;
	}
	function getGmailCode()
	{//Get gmail returned data
		
		if(isset($_REQUEST['code']))
		{
		    $code = $_REQUEST['code'];
            $this->client->authenticate($code);
            $arr= $this->client->getAccessToken();
	
	     return $arr;
		}
		else
		{
			return 0;
		}
	}
	function sendMail($auth,$arr)
	{
		//compose mail
	if($auth !=0 || $auth !=null)
		{
     $client=$this->client;			
    $client->setAccessToken($auth);
    $objGMail = new Google_Service_Gmail($client);
  
    $strRawMessage = "From: ".$arr['from_name']." <".$arr['from'].">\r\n";
	$strRawMessage .= "Reply-to: ".$arr['reply_name']." <".$arr['reply_to'].">\r\n";
	
	if(isset($arr['return_path']))
	{
		if(filter_var($arr['return_path'],FILTER_VALIDATE_EMAIL))
		{
			$strRawMessage .= "Return-Path: ".$arr['return_path']."\r\n";
		}
	}

    $strRawMessage .= "To: ".$arr['to_name']." <".$arr['to'].">\r\n";
    $strRawMessage .= 'Subject: =?utf-8?B?' . base64_encode($arr['subject']) . "?=\r\n";
    $strRawMessage .= "MIME-Version: 1.0\r\n";
    $strRawMessage .= "Content-Type: text/html; charset=utf-8\r\n";
    $strRawMessage .= 'Content-Transfer-Encoding: quoted-printable' . "\r\n\r\n";
    $strRawMessage .= "".$arr['body']."\r\n";
  
    //Users.messages->send - Requires -> Prepare the message in message/rfc822
    try {
        // The message needs to be encoded in Base64URL
        $mime = rtrim(strtr(base64_encode($strRawMessage), '+/', '-_'), '=');
        $msg = new Google_Service_Gmail_Message();
        $msg->setRaw($mime);
  
        //The special value **me** can be used to indicate the authenticated user.
        $objSentMsg = $objGMail->users_messages->send("me", $msg);
  
       /* print('Message sent object');
        print_r($objSentMsg);*/
		
		return 1;
  
    } catch (Exception $e) {
        return $e->getMessage();
        
    }
		}
		else
		{
			return "Invalid Auth String Passed";
		}
	}
}
?>