<?php
set_time_limit(0);

class QmlrSchedular
{
	//Equivalent wp API
    public $mysqli;
    public $table;
	public $timezone;
	public $pref;
	
function __construct()
{
  $path = preg_replace('/wp-content(?!.*wp-content).*/','',__DIR__);
  require($path.'wp-load.php');
   

  $this->pref="wp_quick_mlr_";   
   
  $this->timezone='UTC';	
  date_default_timezone_set($this->timezone);	
  
  self::dbConnection();  
  self::reqControl();  
}

function dbConnection()
{//db connection
    
		global $wpdb;
		$this->mysqli=$wpdb;
        $this->table=$wpdb->prefix."qmlr_api_schedular_table";
}

function reqControl()
{//request controller
	if(isset($_POST['rburl']))
	{
		if(filter_var($_POST['rburl'],FILTER_VALIDATE_URL))
		{
			if(get_option($this->pref."schedule_api_token")==$_POST['auth'])		
			{self::addScheduledMails();}
		}
	}
	elseif(isset($_POST['remschedule']))
	{
		if(isset($_POST['remurl']))
		{
			self::remScheduledMail($_POST['remschedule'], $_POST['remurl']);
		}
	}
	elseif(isset($_GET['runserver']))
	{
		self::runScheduledMails();
	}
	else
	{
		$pref= $this->pref;
		if(get_option($pref.'cron_type')==='script')
		{
			self::runScheduledMails();
		}
		else
		{
			die('<h1>404</h1>');
		}
	}
}

function remScheduledMail($token, $url)
{
	$mysqli=$this->mysqli;
	
	$del=$mysqli->prepare("delete from ".$this->table." where cburl=%s and stoken=%s",array($url,$token));
	
	$mysqli->query($del);
}

function conVertDateTime($date,$time,$zone)
{
	//date-time conversion
	$currentdateob= new DateTime($date.' '.$time, new DateTimeZone($zone));
    $converted=$currentdateob->setTimezone(new DateTimeZone($this->timezone));
    $convertedtime=$converted->format('Y-m-d H:i');
	
	$date=date('Y-m-d',strtotime($convertedtime));
	$time=date('H:i',strtotime($convertedtime));
	
	return array('date'=>$date,'time'=>$time,'time_sec'=>strtotime($date." ".$time));
}

function addScheduledMails()
         {
			 //get request for mail scheduling
			 $mysqli=$this->mysqli;
             $cburl=$_POST['rburl'];
			 $token=$_POST['rtoken'];
			 $stimezone=$_POST['rtimezone'];
			 $sdate=$_POST['rdate'];
			 $stime=$_POST['rtime'];
			 $sip=$_POST['rpip'];
			 $status=$_POST['rstatus'];
			 $getdate=self::conVertDateTime($sdate,$stime,$stimezone);
			 $date=date('d-M-Y');
			 $time=date('h:ia');
			 
			 $sel=$mysqli->get_row($mysqli->prepare("select id from ".$this->table." where cburl=%s and stoken=%s",array($cburl,$token)));
			 
			 
			 if($sel)
			 {
				$in=$mysqli->prepare("update ".$this->table." set cburl=%s,stoken=%s,stime=%d,status=%s,ip=%s,date=%s,time=%s where id=%d",array($cburl,$token,$getdate['time_sec'], $status,$sip,$date,$time,$sel->id));
				$id=$sel->id;
				$updateed=1;
			 }
			 else
			 {
				$in=$mysqli->prepare("INSERT INTO ".$this->table." (cburl,stoken,stime,status,ip,date,time) VALUES (%s,%s,%d,%s,%s,%s,%s)",array($cburl,$token,$getdate['time_sec'],$status,$sip,$date,$time));
			 }
			 $done=$mysqli->query($in);
			 
			 if($done || isset($updateed))
			 {
				 $jsn=array('created'=>true);
				 echo json_encode($jsn);
			 }
			 else
			 {
				 $jsn=array('created'=>false);
				 echo json_encode($jsn);
			 }
			 
         }
function runScheduledMails()
         { 
			$pref= $this->pref;
			$mysqli=$this->mysqli;

			$cron_type= "url";
			$send_all= false;
			if(get_option($pref.'cron_type'))
			{
				$cron_type= get_option($pref.'cron_type');
			}
			if($cron_type==="script")
			{
				global $argv;
				$send_all= true;
			}
			
			$date=date('Y-m-d');
			$time=date('H:i');
			$status='1';

			$tab_stat= "'1'";
			if(get_option($pref.'async_cron_mailer'))
			{
				$async_cron_mailer= (int) get_option($pref.'async_cron_mailer');
				if($async_cron_mailer===1)
				{
					$send_all= false;
					$tab_stat= "'1','2'";
				}
			}
			$id_order= ((mt_rand()%2)===0)? ' desc':'';

			$compose_token= "";

			if(isset($_GET['compose_token']))
			{
				$compose_token= $_GET['compose_token'];
				$compose_token= " and stoken='".$compose_token."'";
				$send_all= false;
			}
			// print_r($argv);
			// print_r($argc);
			// die();

			if(isset($argv[1]) && (strpos($argv[1], '--compose_token--')!==false))
			{
				$compose_token= str_replace('--compose_token--', '', $argv[1]);
				$compose_token= " and stoken='".$compose_token."'";
			}

			$sel=$mysqli->get_results("select id, cburl, stoken from ".$this->table." where `status` in (".$tab_stat.") and (stime<".time()." or stime=".time().")".$compose_token." order by `id`".$id_order.", `status`");

			$_POST= array();
			require_once("ajaxmailsend.php");
			
			if(isset($sel))
			{
				$checked_schedule_count= 0;
				foreach($sel as $r)
				{
					$hhtt_host= (isset($_SERVER['HTTP_HOST']))? $_SERVER['HTTP_HOST']:"";
					$data = array('rwqmlr'=>1,'rtoken'=>$r->stoken,'rurl'=>$r->cburl,'requrl'=>$hhtt_host,'apiurl'=>get_option($this->pref.'schedule_api_url'));
					
					if(strpos($r->cburl, '/ajxlistfunction.php')>0)
					{
						$update=$mysqli->query("update ".$this->table." set status='2' where id=".$r->id."");

						$ch = curl_init();
						curl_setopt($ch, CURLOPT_URL,$r->cburl);
						curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
						curl_setopt($ch, CURLOPT_POST, true);
						curl_setopt($ch, CURLOPT_FRESH_CONNECT,true);
						curl_setopt($ch, CURLOPT_TIMEOUT,60);
						curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
						echo "-Sequence-".PHP_EOL;
						$output = curl_exec($ch);
						echo $output;
					}
					else
					{
						/*
						++$checked_schedule_count;
						if($checked_schedule_count>1)
						{
							continue;
						}
						*/
						$update=$mysqli->query("update ".$this->table." set status='2' where id=".$r->id."");
						echo "-Schedule-\n";
						$sending_stat= wpqmlrDoRunSchedular($data, $this, $send_all);
						if($sending_stat===3)
						{
							continue;
						}
						if($sending_stat===2)
						{
							$re_update=$mysqli->query("update ".$this->table." set status='1' where id=".$r->id."");
						}
					}
				}
			}
            // $info = curl_getinfo($ch);
            // curl_close($ch);
             
         }
}

$ob=new QmlrSchedular();

//$ob->conVertDateTime('2018-11-14','2:02','Asia/Kolkata');





?>